﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Documents.Excel;
using Infragistics.Win.UltraWinGrid;
using System.Diagnostics;

namespace WinGridEachBandInNewSheet
{
    public partial class Form1 : Form
    {
        private DataSet Generate()
        {
            DataTable[] tables = new DataTable[4];

            for (int i = 0; i < 4; i++)
            {
                tables[i] = new DataTable();
                tables[i].Columns.Add("ID", typeof(int)).AutoIncrement = true;
                tables[i].Columns.Add("FID", typeof(int));
                tables[i].Columns.Add("Null", typeof(string));
                for (int col = 0; col < 3; col++)
                    tables[i].Columns.Add("Col" + col.ToString(), typeof(string)).DefaultValue = "Text table" + i.ToString();

            }

            for (int i1 = 0; i1 < 5; i1++)
            {
                tables[0].Rows.Add(null, i1);
                int key0 = (int)tables[0].Rows[i1].ItemArray[0];

                for (int i2 = 0; i2 < 5; i2++)
                {
                    tables[1].Rows.Add(null, key0);
                    int key1 = (int)tables[1].Rows[tables[1].Rows.Count - 1].ItemArray[0];
                    for (int i3 = 0; i3 < 5; i3++)
                    {
                        tables[2].Rows.Add(null, key1);
                        int key2 = (int)tables[2].Rows[tables[2].Rows.Count - 1].ItemArray[0];
                        for (int i4 = 0; i4 < 5; i4++)
                        {
                            tables[3].Rows.Add(null, key2);
                        }
                    }
                }
            }

            DataSet ret = new DataSet();
            ret.Tables.AddRange(tables);


            for (int i = 3; i > 0; i--)
                ret.Relations.Add(ret.Tables[i - 1].Columns["ID"], ret.Tables[i].Columns["FID"]);
            //ret.Relations.Add(ret.Tables[3].Columns["ID"], ret.Tables[0].Columns["FID"]);
            return ret;
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraGrid1.DataSource = Generate();
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            Workbook wb = new Workbook();

            DataSet data = (DataSet)ultraGrid1.DataSource;
            DataSet datarep = data.Copy();
            for (int i = 0; i < data.Tables.Count; i++)
            {
                ultraGrid1.Tag = ultraGrid1.DisplayLayout.Bands[i].Key;
                Worksheet sheet1 = wb.Worksheets.Add(data.Tables[i].TableName);
                UltraGrid ug = new UltraGrid();
                ug.InitializeLayout += new InitializeLayoutEventHandler(ug_InitializeLayout);
                this.Controls.Add(ug);
                ug.DataSource = data.Tables[i].Copy();
                
                ultraGridExcelExporter1.Export(ug, sheet1, 0, 0);
                ug.Dispose();
            }


            wb.Save("Test.xls");

            Process.Start("Test.xls");
            
        }

        

        void ug_InitializeLayout(object sender, InitializeLayoutEventArgs e)
        {
            foreach (UltraGridColumn c in e.Layout.Bands[0].Columns)
            {
                c.Hidden = ultraGrid1.DisplayLayout.Bands[(string)ultraGrid1.Tag].Columns[c.Key].Hidden;
            }

        }

       
    }
}
